
namespace IRDB_SDK
{
	using namespace std;
	enum CFGEdgeTypeEnum { cetFallthroughEdge, cetTargetEdge, cetIndirectEdge };
	using CFGEdgeType_t = set<CFGEdgeTypeEnum>;

	class ControlFlowGraph_t
	{
		protected:
			ControlFlowGraph_t() { }
			ControlFlowGraph_t(const ControlFlowGraph_t& copy)  = delete;
		public:

			virtual BasicBlock_t*          getEntry()                                                        const = 0 ;
			virtual Function_t*            getFunction()                                                     const = 0 ;
			virtual const BasicBlockSet_t& getBlocks()                                                       const = 0 ;
			virtual bool                   hasEdge(BasicBlock_t *p_src, BasicBlock_t *p_tgt)                 const = 0 ;
			virtual CFGEdgeType_t          getEdgeType(const BasicBlock_t *p_src, const BasicBlock_t *p_tgt) const = 0 ;
			virtual void                   dump(ostream &os=cout)                                            const = 0 ;

		// factories
			static unique_ptr<ControlFlowGraph_t> factory(Function_t* func);

	};
	ostream& operator<<(ostream& os, const ControlFlowGraph_t& cfg);

}
