
namespace IRDB_SDK
{
	using namespace std;
	using BasicBlockEdge_t    =  tuple<BasicBlock_t*, BasicBlock_t*>;
	using BasicBlockEdgeSet_t =  set<BasicBlockEdge_t> ;

	class CriticalEdges_t
	{
		protected:
			CriticalEdges_t(){}	
			CriticalEdges_t(const CriticalEdges_t& copy) = delete;
		public:
			static unique_ptr<CriticalEdges_t> factory(
			                                           const ControlFlowGraph_t &p_cfg, 
			                                           const bool p_conservative=true
			                                          );

			virtual const BasicBlockEdgeSet_t& getAllCriticalEdges() const = 0;
	};

}
