
namespace IRDB_SDK
{

	using namespace std;

	using  DominatorMap_t    = map<const BasicBlock_t*, BasicBlockSet_t>; 
	using  BlockToBlockMap_t = map<const BasicBlock_t*, BasicBlock_t*>;

	class DominatorGraph_t
	{
		protected:
			DominatorGraph_t(){}
			DominatorGraph_t(const DominatorGraph_t& copy)=delete;
		public:
			static unique_ptr<DominatorGraph_t> factory(
			                                      const ControlFlowGraph_t* p_cfg, 
			                                      bool needs_postdoms=false, 
			                                      bool needs_idoms=false
			                                      );

			virtual const BasicBlockSet_t& getDominators(const BasicBlock_t* node)               const = 0 ;
			virtual const BasicBlockSet_t& getPostDominators(const BasicBlock_t* node)           const = 0 ;
			virtual bool                   hasWarnings()                                         const = 0 ;
			virtual const BasicBlock_t*    getImmediateDominator(const BasicBlock_t* node)       const = 0 ;
			virtual const BasicBlock_t*    getImmediatePostDominators(const BasicBlock_t* node)  const = 0 ;
			virtual void                   dump(ostream &os=cout)                                const = 0 ;
	
	};
	ostream& operator<<(ostream& os, const DominatorGraph_t& cfg);

}

