
#include <irdb-core>
#include <irdb-transform>
#include <string>
#include <memory>


namespace IRDB_SDK
{

using namespace std;

class ElfDependencies_t 
{
	protected:
		ElfDependencies_t() { } 
		ElfDependencies_t(const ElfDependencies_t& copy) = delete;
	public:
		virtual ~ElfDependencies_t() { } 

		virtual void prependLibraryDepedencies(const string& libName) = 0; 
		virtual void appendLibraryDepedencies(const string& libName)  = 0; 

		// return scoop and offset
		virtual pair<IRDB_SDK::DataScoop_t*,int> appendGotEntry(const string &symbolName)   = 0 ;

		// return instruction that's the plt entry.
		virtual Instruction_t* appendPltEntry(const string &symbolName)   = 0 ;

		static unique_ptr<ElfDependencies_t> factory(IRDB_SDK::FileIR_t* firp);

};


}
