#include <string>
#include <set>
#include <map>
#include <irdb-core>

namespace IRDB_SDK
{

	using namespace std;

	class Transform 
	{

		public:
			Transform(FileIR_t * file); 
			virtual ~Transform() { } 

			Instruction_t* insertAssemblyBefore  (Instruction_t* p_before, const string &p_asm, Instruction_t* p_targ=nullptr);
			Instruction_t* insertAssemblyAfter   (Instruction_t* p_after , const string &p_asm, Instruction_t* p_targ=nullptr);
			Instruction_t* insertDataBitsBefore  (Instruction_t* p_before, const string &p_asm, Instruction_t* p_targ=nullptr);
			Instruction_t* insertDataBitsAfter   (Instruction_t* p_after , const string &p_asm, Instruction_t* p_targ=nullptr);

			Instruction_t* addNewDataBits        (const string& p_bits);
			Instruction_t* addNewAssembly        (const string& p_asm);

			void setInstructionAssembly(
					Instruction_t* instr, 
					const string& p_asm, 
					Instruction_t *p_new_fallthrough, 
					Instruction_t* p_new_target=nullptr);

			void setInstructionAssembly(Instruction_t* instr, const string& p_asm);


			FileIR_t* getFileIR();  
			const FileIR_t* getFileIR() const;  

		private:

			FileIR_t    *m_fileIR;
	};

}


